settings.prc = false;
settings.render = 0;
settings.outformat = "pdf";

size(200);

defaultpen(1);
pen blackpen = black + 1bp;

pair O = (0, 0);
pair A = (1, 1);
pair B = (-1, 1);
pair C = (-1, -1);
pair D = (1, -1);
pair ABmid = (0, 1);
pair BCmid = (-1, 0);
pair CDmid = (0, -1);
pair DAmid = (1, 0);

// Draw hexadecant (behind)
pair mid = intersectionpoints(O -- D, CDmid -- DAmid)[0];
fill(O -- DAmid -- mid -- cycle, rgb('cccccc'));

// Draw square
draw(A -- B, gray+1.5bp);
draw(B -- C, gray+1.5bp);
draw(C -- D, gray+1.5bp);
draw(D -- A, gray+1.5bp);

// Draw quadrants and octants
draw(O -- ABmid, gray+1.5bp);
draw(O -- BCmid, gray+1.5bp);
draw(ABmid -- BCmid, gray+1.5bp);
draw(BCmid -- CDmid, gray+1.5bp);
draw(DAmid -- ABmid, gray+1.5bp);

draw(O -- A, gray+1.5bp);
draw(O -- B, gray+1.5bp);
draw(O -- C, gray+1.5bp);
draw(O -- D, gray+1.5bp);

draw(CDmid -- DAmid, black+1.5bp);
draw(O -- CDmid, black+1.5bp);
draw(O -- DAmid, black+1.5bp);
